
true = 'true'
false = None

class DatabaseMetadata:

    def __init__ (self, session):
        self.session = session
        if has_attr (session, 'cursor'):
            self.select = self.stdSelect
        else:
            self.select = self.proprietarySelect

    def stdSelect (self, sql, arguments = []):
        """execute SELECT using DB API
        """
        cursor = self.session.cursor ()
        cursor.execute (sql, arguments)
        return cursor

    def proprietarySelect (self, sql, aruments = []):
        """execute SELECT using module sapdb
        """
        if arguments:
            return self.session.sqlX (sql, arguments)
        else:
            return self.session.sql (sql)
    # 
    # Indicates that the best row identifier is NOT a pseudo column.
    # <P>
    # A possible value for the column
    # <code>PSEUDO_COLUMN</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getBestRowIdentifier</code>.
    bestRowNotPseudo = 1

    # 
    # Indicates that the best row identifier is a pseudo column.
    # <P>
    # A possible value for the column
    # <code>PSEUDO_COLUMN</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getBestRowIdentifier</code>.
    bestRowPseudo = 2

    # 
    # Indicates that the scope of the best row identifier is
    # the remainder of the current session.
    # <P>
    # A possible value for the column
    # <code>SCOPE</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getBestRowIdentifier</code>.
    bestRowSession = 2

    # 
    # Indicates that the scope of the best row identifier is
    # very temporary, lasting only while the
    # row is being used.
    # <P>
    # A possible value for the column
    # <code>SCOPE</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getBestRowIdentifier</code>.
    bestRowTemporary = 0

    # 
    # Indicates that the scope of the best row identifier is
    # the remainder of the current transaction.
    # <P>
    # A possible value for the column
    # <code>SCOPE</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getBestRowIdentifier</code>.
    bestRowTransaction = 1

    # 
    # Indicates that the best row identifier may or may not be a pseudo column.
    # <P>
    # A possible value for the column
    # <code>PSEUDO_COLUMN</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getBestRowIdentifier</code>.
    bestRowUnknown = 0

    # 
    # Indicates that the column might not allow <code>NULL</code> values.
    # <P>
    # A possible value for the column
    # <code>NULLABLE</code>
    # in the <code>ResultSet</code> returned by the method
    # <code>getColumns</code>.
    columnNoNulls = 0

    # 
    # Indicates that the column definitely allows <code>NULL</code> values.
    # <P>
    # A possible value for the column
    # <code>NULLABLE</code>
    # in the <code>ResultSet</code> returned by the method
    # <code>getColumns</code>.
    columnNullable = 1

    # 
    # Indicates that the nullability of columns is unknown.
    # <P>
    # A possible value for the column
    # <code>NULLABLE</code>
    # in the <code>ResultSet</code> returned by the method
    # <code>getColumns</code>.
    columnNullableUnknown = 2

    # 
    # For the column <code>UPDATE_RULE</code>,
    # indicates that
    # when the primary key is updated, the foreign key (imported key)
    # is changed to agree with it.
    # For the column <code>DELETE_RULE</code>,
    # it indicates that
    # when the primary key is deleted, rows that imported that key
    # are deleted.
    # <P>
    # A possible value for the columns <code>UPDATE_RULE</code>
    # and <code>DELETE_RULE</code> in the
    # <code>ResultSet</code> objects returned by the methods
    # <code>getImportedKeys</code>,  <code>getExportedKeys</code>,
    # and <code>getCrossReference</code>.
    importedKeyCascade = 0

    # 
    # Indicates deferrability.  See SQL-92 for a definition.
    # <P>
    # A possible value for the column <code>DEFERRABILITY</code>
    # in the <code>ResultSet</code> objects returned by the methods
    # <code>getImportedKeys</code>,  <code>getExportedKeys</code>,
    # and <code>getCrossReference</code>.
    importedKeyInitiallyDeferred = 5

    # 
    # Indicates deferrability.  See SQL-92 for a definition.
    # <P>
    # A possible value for the column <code>DEFERRABILITY</code>
    # in the <code>ResultSet</code> objects returned by the methods
    # <code>getImportedKeys</code>,  <code>getExportedKeys</code>,
    # and <code>getCrossReference</code>.
    importedKeyInitiallyImmediate = 6

    # 
    # For the columns <code>UPDATE_RULE</code>
    # and <code>DELETE_RULE</code>, indicates that
    # if the primary key has been imported, it cannot be updated or deleted.
    # <P>
    # A possible value for the columns <code>UPDATE_RULE</code>
    # and <code>DELETE_RULE</code> in the
    # <code>ResultSet</code> objects returned by the methods
    # <code>getImportedKeys</code>,  <code>getExportedKeys</code>,
    # and <code>getCrossReference</code>.
    importedKeyNoAction = 3

    # 
    # Indicates deferrability.  See SQL-92 for a definition.
    # <P>
    # A possible value for the column <code>DEFERRABILITY</code>
    # in the <code>ResultSet</code> objects returned by the methods
    # <code>getImportedKeys</code>,  <code>getExportedKeys</code>,
    # and <code>getCrossReference</code>.
    importedKeyNotDeferrable = 7

    # 
    # For the column <code>UPDATE_RULE</code>, indicates that
    # a primary key may not be updated if it has been imported by
    # another table as a foreign key.
    # For the column <code>DELETE_RULE</code>, indicates that
    # a primary key may not be deleted if it has been imported by
    # another table as a foreign key.
    # <P>
    # A possible value for the columns <code>UPDATE_RULE</code>
    # and <code>DELETE_RULE</code> in the
    # <code>ResultSet</code> objects returned by the methods
    # <code>getImportedKeys</code>,  <code>getExportedKeys</code>,
    # and <code>getCrossReference</code>.
    importedKeyRestrict = 1

    # 
    # For the columns <code>UPDATE_RULE</code>
    # and <code>DELETE_RULE</code>, indicates that
    # if the primary key is updated or deleted, the foreign key (imported key)
    # is set to the default value.
    # <P>
    # A possible value for the columns <code>UPDATE_RULE</code>
    # and <code>DELETE_RULE</code> in the
    # <code>ResultSet</code> objects returned by the methods
    # <code>getImportedKeys</code>,  <code>getExportedKeys</code>,
    # and <code>getCrossReference</code>.
    importedKeySetDefault = 4

    # 
    # For the columns <code>UPDATE_RULE</code>
    # and <code>DELETE_RULE</code>, indicates that
    # when the primary key is updated or deleted, the foreign key (imported key)
    # is changed to <code>NULL</code>.
    # <P>
    # A possible value for the columns <code>UPDATE_RULE</code>
    # and <code>DELETE_RULE</code> in the
    # <code>ResultSet</code> objects returned by the methods
    # <code>getImportedKeys</code>,  <code>getExportedKeys</code>,
    # and <code>getCrossReference</code>.
    importedKeySetNull = 2

    # 
    # Indicates that the column stores IN parameters.
    # <P>
    # A possible value for the column
    # <code>COLUMN_TYPE</code>
    # in the <code>ResultSet</code> 
    # returned by the method <code>getProcedureColumns</code>.
    procedureColumnIn = 1

    # 
    # Indicates that the column stores INOUT parameters.
    # <P>
    # A possible value for the column
    # <code>COLUMN_TYPE</code>
    # in the <code>ResultSet</code> 
    # returned by the method <code>getProcedureColumns</code>.
    procedureColumnInOut = 2

    # 
    # Indicates that the column stores OUT parameters.
    # <P>
    # A possible value for the column
    # <code>COLUMN_TYPE</code>
    # in the <code>ResultSet</code> 
    # returned by the method <code>getProcedureColumns</code>.
    procedureColumnOut = 4

    # 
    # Indicates that the column stores results.
    # <P>
    # A possible value for the column
    # <code>COLUMN_TYPE</code>
    # in the <code>ResultSet</code> 
    # returned by the method <code>getProcedureColumns</code>.
    procedureColumnResult = 3

    # 
    # Indicates that the column stores return values.
    # <P>
    # A possible value for the column
    # <code>COLUMN_TYPE</code>
    # in the <code>ResultSet</code> 
    # returned by the method <code>getProcedureColumns</code>.
    procedureColumnReturn = 5

    # 
    # Indicates that type of the column is unknown.
    # <P>
    # A possible value for the column
    # <code>COLUMN_TYPE</code>
    # in the <code>ResultSet</code> 
    # returned by the method <code>getProcedureColumns</code>.
    procedureColumnUnknown = 0

    # 
    # Indicates that <code>NULL</code> values are not allowed.
    # <P>
    # A possible value for the column
    # <code>NULLABLE</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getProcedureColumns</code>.
    procedureNoNulls = 0

    # 
    # Indicates that the procedure does not return a result.
    # <P>
    # A possible value for column <code>PROCEDURE_TYPE</code> in the
    # <code>ResultSet</code> object returned by the method
    # <code>getProcedures</code>.
    procedureNoResult = 1

    # 
    # Indicates that <code>NULL</code> values are allowed.
    # <P>
    # A possible value for the column
    # <code>NULLABLE</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getProcedureColumns</code>.
    procedureNullable = 1

    # 
    # Indicates that whether <code>NULL</code> values are allowed
    # is unknown.
    # <P>
    # A possible value for the column
    # <code>NULLABLE</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getProcedureColumns</code>.
    procedureNullableUnknown = 2

    # 
    # Indicates that it is not known whether the procedure returns
    # a result.
    # <P>
    # A possible value for column <code>PROCEDURE_TYPE</code> in the
    # <code>ResultSet</code> object returned by the method
    # <code>getProcedures</code>.
    procedureResultUnknown = 0

    # 
    # Indicates that the procedure returns a result.
    # <P>
    # A possible value for column <code>PROCEDURE_TYPE</code> in the
    # <code>ResultSet</code> object returned by the method
    # <code>getProcedures</code>.
    procedureReturnsResult = 2

    # 
    # Indicates that the value is an SQL99 SQLSTATE value.
    # <P>
    # A possible return value for the method
    # <code>SQLException.getSQLState</code>.
    # @since 1.4
    sqlStateSQL99 = 2

    # 
    # Indicates that the value is an
    # X/Open (now know as Open Group) SQL CLI SQLSTATE value.
    # <P>
    # A possible return value for the method
    # <code>SQLException.getSQLState</code>.
    # @since 1.4
    sqlStateXOpen = 1

    # 
    # Indicates that a <code>NULL</code> value is NOT allowed for this
    # data type.
    # <P>
    # A possible value for column <code>NULLABLE</code> in the
    # <code>ResultSet</code> object returned by the method
    # <code>getTypeInfo</code>.
    typeNoNulls = 0

    # 
    # Indicates that a <code>NULL</code> value is allowed for this
    # data type.
    # <P>
    # A possible value for column <code>NULLABLE</code> in the
    # <code>ResultSet</code> object returned by the method
    # <code>getTypeInfo</code>.
    typeNullable = 1

    # 
    # Indicates that it is not known whether a <code>NULL</code> value 
    # is allowed for this data type.
    # <P>
    # A possible value for column <code>NULLABLE</code> in the
    # <code>ResultSet</code> object returned by the method
    # <code>getTypeInfo</code>.
    typeNullableUnknown = 2

    # 
    # Indicates that one can base all <code>WHERE</code> search clauses 
    # except <code>WHERE . . . LIKE</code> on this data type.
    # <P>
    # A possible value for column <code>SEARCHABLE</code> in the
    # <code>ResultSet</code> object returned by the method
    # <code>getTypeInfo</code>.
    typePredBasic = 2

    # 
    # Indicates that the only <code>WHERE</code> search clause that can
    # be based on this type is <code>WHERE . . . LIKE</code>.
    # <P>
    # A possible value for column <code>SEARCHABLE</code> in the
    # <code>ResultSet</code> object returned by the method
    # <code>getTypeInfo</code>.
    typePredChar = 1

    # 
    # Indicates that <code>WHERE</code> search clauses are not supported
    # for this type.
    # <P>
    # A possible value for column <code>SEARCHABLE</code> in the
    # <code>ResultSet</code> object returned by the method
    # <code>getTypeInfo</code>.
    typePredNone = 0

    # 
    # Indicates that all <code>WHERE</code> search clauses can be 
    # based on this type.
    # <P>
    # A possible value for column <code>SEARCHABLE</code> in the
    # <code>ResultSet</code> object returned by the method
    # <code>getTypeInfo</code>.
    typeSearchable = 3

    # 
    # Indicates that this version column is NOT a pseudo column.
    # <P>
    # A possible value for the column
    # <code>PSEUDO_COLUMN</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getVersionColumns</code>.
    versionColumnNotPseudo = 1

    # 
    # Indicates that this version column is a pseudo column.
    # <P>
    # A possible value for the column
    # <code>PSEUDO_COLUMN</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getVersionColumns</code>.
    versionColumnPseudo = 2

    # 
    # Indicates that this version column may or may not be a pseudo column.
    # <P>
    # A possible value for the column
    # <code>PSEUDO_COLUMN</code>
    # in the <code>ResultSet</code> object
    # returned by the method <code>getVersionColumns</code>.
    versionColumnUnknown = 0

    def allProceduresAreCallable (self):
        """
        Retrieves whether the current user can call all the procedures 
        returned by the method <code>getProcedures</code>.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end allProceduresAreCallable

    def allTablesAreSelectable (self):
        """
        Retrieves whether the current user can use all the tables returned 
        by the method <code>getTables</code> in a <code>SELECT</code> 
        statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end allTablesAreSelectable

    def dataDefinitionCausesTransactionCommit (self):
        """
        Retrieves whether a data definition statement within a transaction forces
        the transaction to commit.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end dataDefinitionCausesTransactionCommit

    def dataDefinitionIgnoredInTransactions (self):
        """
        Retrieves whether this database ignores a data definition statement 
        within a transaction.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end dataDefinitionIgnoredInTransactions

    def deletesAreDetected (self, type):
        """
        Retrieves whether or not a visible row delete can be detected by 
        calling the method <code>ResultSet.rowDeleted</code>.  If the method
        <code>deletesAreDetected</code> returns <code>false</code>, it means that
        deleted rows are removed from the result set.
        
        @param type the <code>ResultSet</code> type; one of
        <code>ResultSet.TYPE_FORWARD_ONLY</code>,
        <code>ResultSet.TYPE_SCROLL_INSENSITIVE</code>, or
        <code>ResultSet.TYPE_SCROLL_SENSITIVE</code>
        @return <code>true</code> if deletes are detected by the given result set type;
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end deletesAreDetected
    del deletesAreDetected

    def doesMaxRowSizeIncludeBlobs (self):
        """
        Retrieves whether the return value for the method 
        <code>getMaxRowSize</code> includes the SQL data types 
        <code>LONGVARCHAR</code> and <code>LONGVARBINARY</code>.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end doesMaxRowSizeIncludeBlobs

    def getAttributes (self, catalog, schemaPattern, typeNamePattern, attributeNamePattern):
        """
        Retrieves a description of the given attribute of the given type 
        for a user-defined type (UDT) that is available in the given schema 
        and catalog.
        <P>
        Descriptions are returned only for attributes of UDTs matching the 
        catalog, schema, type, and attribute name criteria. They are ordered by
        TYPE_SCHEM, TYPE_NAME and ORDINAL_POSITION. This description
        does not contain inherited attributes.
        <P>
        The <code>ResultSet</code> object that is returned has the following 
        columns:
        <OL>
        <LI><B>TYPE_CAT</B> String => type catalog (may be <code>null</code>)
        <LI><B>TYPE_SCHEM</B> String => type schema (may be <code>null</code>)
        <LI><B>TYPE_NAME</B> String => type name
        <LI><B>ATTR_NAME</B> String => attribute name
        <LI><B>DATA_TYPE</B> short => attribute type SQL type from java.sql.Types
        <LI><B>ATTR_TYPE_NAME</B> String => Data source dependent type name.
        For a UDT, the type name is fully qualified. For a REF, the type name is 
        fully qualified and represents the target type of the reference type.
        <LI><B>ATTR_SIZE</B> int => column size.  For char or date
        types this is the maximum number of characters; for numeric or
        decimal types this is precision.
        <LI><B>DECIMAL_DIGITS</B> int => the number of fractional digits
        <LI><B>NUM_PREC_RADIX</B> int => Radix (typically either 10 or 2)
        <LI><B>NULLABLE</B> int => whether NULL is allowed
        <UL>
        <LI> attributeNoNulls - might not allow NULL values
        <LI> attributeNullable - definitely allows NULL values
        <LI> attributeNullableUnknown - nullability unknown
        </UL>
        <LI><B>REMARKS</B> String => comment describing column (may be <code>null</code>)
        <LI><B>ATTR_DEF</B> String => default value (may be <code>null</code>)
        <LI><B>SQL_DATA_TYPE</B> int => unused
        <LI><B>SQL_DATETIME_SUB</B> int => unused
        <LI><B>CHAR_OCTET_LENGTH</B> int => for char types the 
        maximum number of bytes in the column
        <LI><B>ORDINAL_POSITION</B> int	=> index of column in table 
        (starting at 1)
        <LI><B>IS_NULLABLE</B> String => "NO" means column definitely 
        does not allow NULL values; "YES" means the column might 
        allow NULL values.  An empty string means unknown.
        <LI><B>SCOPE_CATALOG</B> String => catalog of table that is the
        scope of a reference attribute (<code>null</code> if DATA_TYPE isn't REF)
        <LI><B>SCOPE_SCHEMA</B> String => schema of table that is the 
        scope of a reference attribute (<code>null</code> if DATA_TYPE isn't REF)
        <LI><B>SCOPE_TABLE</B> String => table name that is the scope of a 
        reference attribute (<code>null</code> if the DATA_TYPE isn't REF)
        <LI><B>SOURCE_DATA_TYPE</B> short => source type of a distinct type or user-generated
        Ref type,SQL type from java.sql.Types (<code>null</code> if DATA_TYPE 
        isn't DISTINCT or user-generated REF)
        </OL>
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schemaPattern a schema name pattern; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param typeNamePattern a type name pattern; must match the
        type name as it is stored in the database 
        @param attributeNamePattern an attribute name pattern; must match the attribute
        name as it is declared in the database
        @return a <code>ResultSet</code> object in which each row is an 
        attribute description
        @exception SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end getAttributes
    del getAttributes

    def getBestRowIdentifier (self, catalog, schema, table, scope, nullable):
        """
        Retrieves a description of a table's optimal set of columns that
        uniquely identifies a row. They are ordered by SCOPE.
        
        <P>Each column description has the following columns:
        <OL>
        <LI><B>SCOPE</B> short => actual scope of result
        <UL>
        <LI> bestRowTemporary - very temporary, while using row
        <LI> bestRowTransaction - valid for remainder of current transaction
        <LI> bestRowSession - valid for remainder of current session
        </UL>
        <LI><B>COLUMN_NAME</B> String => column name
        <LI><B>DATA_TYPE</B> short => SQL data type from java.sql.Types
        <LI><B>TYPE_NAME</B> String => Data source dependent type name,
        for a UDT the type name is fully qualified
        <LI><B>COLUMN_SIZE</B> int => precision
        <LI><B>BUFFER_LENGTH</B> int => not used
        <LI><B>DECIMAL_DIGITS</B> short	 => scale
        <LI><B>PSEUDO_COLUMN</B> short => is this a pseudo column 
        like an Oracle ROWID
        <UL>
        <LI> bestRowUnknown - may or may not be pseudo column
        <LI> bestRowNotPseudo - is NOT a pseudo column
        <LI> bestRowPseudo - is a pseudo column
        </UL>
        </OL>
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schema a schema name; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param table a table name; must match the table name as it is stored 
        in the database 
        @param scope the scope of interest; use same values as SCOPE
        @param nullable include columns that are nullable.
        @return <code>ResultSet</code> - each row is a column description 
        @exception SQLException if a database access error occurs
        """
        pass
    # end getBestRowIdentifier
    del getBestRowIdentifier

    def getCatalogSeparator (self):
        """
        Retrieves the <code>String</code> that this database uses as the 
        separator between a catalog and table name.
        
        @return the separator string
        @exception SQLException if a database access error occurs
        """
        return '.'
    # end getCatalogSeparator

    def getCatalogTerm (self):
        """
        Retrieves the database vendor's preferred term for "catalog".
        
        @return the vendor term for "catalog"
        @exception SQLException if a database access error occurs
        """
        return 'CAT'
    # end getCatalogTerm

    def getCatalogs (self):
        """
        Retrieves the catalog names available in this database.  The results
        are ordered by catalog name.
        
        <P>The catalog column is:
        <OL>
        <LI><B>TABLE_CAT</B> String => catalog name
        </OL>
        
        @return a <code>ResultSet</code> object in which each row has a 
        single <code>String</code> column that is a catalog name 
        @exception SQLException if a database access error occurs
        """
        pass
    # end getCatalogs
    del getCatalogs

    def getColumnPrivileges (self, catalog, schema, table, columnNamePattern):
        """
        Retrieves a description of the access rights for a table's columns.
        
        <P>Only privileges matching the column name criteria are
        returned.  They are ordered by COLUMN_NAME and PRIVILEGE.
        
        <P>Each privilige description has the following columns:
        <OL>
        <LI><B>TABLE_CAT</B> String => table catalog (may be <code>null</code>)
        <LI><B>TABLE_SCHEM</B> String => table schema (may be <code>null</code>)
        <LI><B>TABLE_NAME</B> String => table name
        <LI><B>COLUMN_NAME</B> String => column name
        <LI><B>GRANTOR</B> => grantor of access (may be <code>null</code>)
        <LI><B>GRANTEE</B> String => grantee of access
        <LI><B>PRIVILEGE</B> String => name of access (SELECT, 
        INSERT, UPDATE, REFRENCES, ...)
        <LI><B>IS_GRANTABLE</B> String => "YES" if grantee is permitted 
        to grant to others; "NO" if not; <code>null</code> if unknown 
        </OL>
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schema a schema name; must match the schema name as it is
        stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param table a table name; must match the table name as it is
        stored in the database 
        @param columnNamePattern a column name pattern; must match the column
        name as it is stored in the database
        @return <code>ResultSet</code> - each row is a column privilege description
        @exception SQLException if a database access error occurs
        @see #getSearchStringEscape 
        """
        pass
    # end getColumnPrivileges
    del getColumnPrivileges

    def getColumns (self, catalog, schemaPattern, tableNamePattern, columnNamePattern):
        """
        Retrieves a description of table columns available in 
        the specified catalog.
        
        <P>Only column descriptions matching the catalog, schema, table
        and column name criteria are returned.  They are ordered by
        <code>TABLE_SCHEM</code>, <code>TABLE_NAME</code>, and 
        <code>ORDINAL_POSITION</code>.
        
        <P>Each column description has the following columns:
        <OL>
        <LI><B>TABLE_CAT</B> String => table catalog (may be <code>null</code>)
        <LI><B>TABLE_SCHEM</B> String => table schema (may be <code>null</code>)
        <LI><B>TABLE_NAME</B> String => table name
        <LI><B>COLUMN_NAME</B> String => column name
        <LI><B>DATA_TYPE</B> short => SQL type from java.sql.Types
        <LI><B>TYPE_NAME</B> String => Data source dependent type name,
        for a UDT the type name is fully qualified
        <LI><B>COLUMN_SIZE</B> int => column size.  For char or date
        types this is the maximum number of characters, for numeric or
        decimal types this is precision.
        <LI><B>BUFFER_LENGTH</B> is not used.
        <LI><B>DECIMAL_DIGITS</B> int => the number of fractional digits
        <LI><B>NUM_PREC_RADIX</B> int => Radix (typically either 10 or 2)
        <LI><B>NULLABLE</B> int => is NULL allowed.
        <UL>
        <LI> columnNoNulls - might not allow <code>NULL</code> values
        <LI> columnNullable - definitely allows <code>NULL</code> values
        <LI> columnNullableUnknown - nullability unknown
        </UL>
        <LI><B>REMARKS</B> String => comment describing column (may be <code>null</code>)
        <LI><B>COLUMN_DEF</B> String => default value (may be <code>null</code>)
        <LI><B>SQL_DATA_TYPE</B> int => unused
        <LI><B>SQL_DATETIME_SUB</B> int => unused
        <LI><B>CHAR_OCTET_LENGTH</B> int => for char types the 
        maximum number of bytes in the column
        <LI><B>ORDINAL_POSITION</B> int	=> index of column in table 
        (starting at 1)
        <LI><B>IS_NULLABLE</B> String => "NO" means column definitely 
        does not allow NULL values; "YES" means the column might 
        allow NULL values.  An empty string means nobody knows.
        <LI><B>SCOPE_CATLOG</B> String => catalog of table that is the scope
        of a reference attribute (<code>null</code> if DATA_TYPE isn't REF)
        <LI><B>SCOPE_SCHEMA</B> String => schema of table that is the scope
        of a reference attribute (<code>null</code> if the DATA_TYPE isn't REF)
        <LI><B>SCOPE_TABLE</B> String => table name that this the scope
        of a reference attribure (<code>null</code> if the DATA_TYPE isn't REF)
        <LI><B>SOURCE_DATA_TYPE</B> short => source type of a distinct type or user-generated
        Ref type, SQL type from java.sql.Types (<code>null</code> if DATA_TYPE 
        isn't DISTINCT or user-generated REF)
        </OL>
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schemaPattern a schema name pattern; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param tableNamePattern a table name pattern; must match the
        table name as it is stored in the database 
        @param columnNamePattern a column name pattern; must match the column
        name as it is stored in the database
        @return <code>ResultSet</code> - each row is a column description
        @exception SQLException if a database access error occurs
        @see #getSearchStringEscape 
        """
        pass
    # end getColumns
    del getColumns

    def getConnection (self):
        """
        Retrieves the connection that produced this metadata object.
        <P>
        @return the connection that produced this metadata object
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end getConnection
    del getConnection

    def getCrossReference (self, primaryCatalog, primarySchema, primaryTable, foreignCatalog, foreignSchema, foreignTable):
        """
        Retrieves a description of the foreign key columns in the given foreign key
        table that reference the primary key columns of the given primary key
        table (describe how one table imports another's key). This
        should normally return a single foreign key/primary key pair because
        most tables import a foreign key from a table only once.  They
        are ordered by FKTABLE_CAT, FKTABLE_SCHEM, FKTABLE_NAME, and
        KEY_SEQ.
        
        <P>Each foreign key column description has the following columns:
        <OL>
        <LI><B>PKTABLE_CAT</B> String => primary key table catalog (may be <code>null</code>)
        <LI><B>PKTABLE_SCHEM</B> String => primary key table schema (may be <code>null</code>)
        <LI><B>PKTABLE_NAME</B> String => primary key table name
        <LI><B>PKCOLUMN_NAME</B> String => primary key column name
        <LI><B>FKTABLE_CAT</B> String => foreign key table catalog (may be <code>null</code>)
        being exported (may be <code>null</code>)
        <LI><B>FKTABLE_SCHEM</B> String => foreign key table schema (may be <code>null</code>)
        being exported (may be <code>null</code>)
        <LI><B>FKTABLE_NAME</B> String => foreign key table name
        being exported
        <LI><B>FKCOLUMN_NAME</B> String => foreign key column name
        being exported
        <LI><B>KEY_SEQ</B> short => sequence number within foreign key
        <LI><B>UPDATE_RULE</B> short => What happens to 
        foreign key when primary is updated:
        <UL>
        <LI> importedNoAction - do not allow update of primary 
        key if it has been imported
        <LI> importedKeyCascade - change imported key to agree 
        with primary key update
        <LI> importedKeySetNull - change imported key to <code>NULL</code> if 
        its primary key has been updated
        <LI> importedKeySetDefault - change imported key to default values 
        if its primary key has been updated
        <LI> importedKeyRestrict - same as importedKeyNoAction 
        (for ODBC 2.x compatibility)
        </UL>
        <LI><B>DELETE_RULE</B> short => What happens to 
        the foreign key when primary is deleted.
        <UL>
        <LI> importedKeyNoAction - do not allow delete of primary 
        key if it has been imported
        <LI> importedKeyCascade - delete rows that import a deleted key
        <LI> importedKeySetNull - change imported key to <code>NULL</code> if 
        its primary key has been deleted
        <LI> importedKeyRestrict - same as importedKeyNoAction 
        (for ODBC 2.x compatibility)
        <LI> importedKeySetDefault - change imported key to default if 
        its primary key has been deleted
        </UL>
        <LI><B>FK_NAME</B> String => foreign key name (may be <code>null</code>)
        <LI><B>PK_NAME</B> String => primary key name (may be <code>null</code>)
        <LI><B>DEFERRABILITY</B> short => can the evaluation of foreign key 
        constraints be deferred until commit
        <UL>
        <LI> importedKeyInitiallyDeferred - see SQL92 for definition
        <LI> importedKeyInitiallyImmediate - see SQL92 for definition 
        <LI> importedKeyNotDeferrable - see SQL92 for definition 
        </UL>
        </OL>
        
        @param primaryCatalog a catalog name; must match the catalog name
        as it is stored in the database; "" retrieves those without a
        catalog; <code>null</code> means drop catalog name from the selection criteria 
        @param primarySchema a schema name; must match the schema name as
        it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means drop schema name from the selection criteria 
        @param primaryTable the name of the table that exports the key; must match
        the table name as it is stored in the database
        @param foreignCatalog a catalog name; must match the catalog name as
        it is stored in the database; "" retrieves those without a
        catalog; <code>null</code> means drop catalog name from the selection criteria
        @param foreignSchema a schema name; must match the schema name as it
        is stored in the database; "" retrieves those without a schema;
        <code>null</code> means drop schema name from the selection criteria 
        @param foreignTable the name of the table that imports the key; must match
        the table name as it is stored in the database
        @return <code>ResultSet</code> - each row is a foreign key column description 
        @exception SQLException if a database access error occurs
        @see #getImportedKeys 
        """
        pass
    # end getCrossReference
    del getCrossReference

    def getDatabaseMajorVersion (self):
        """
        Retrieves the major version number of the underlying database.
        
        @return the underlying database's major version
        @exception SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end getDatabaseMajorVersion
    del getDatabaseMajorVersion

    def getDatabaseMinorVersion (self):
        """
        Retrieves the minor version number of the underlying database.
        
        @return underlying database's minor version
        @exception SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end getDatabaseMinorVersion
    del getDatabaseMinorVersion

    def getDatabaseProductName (self):
        """
        Retrieves the name of this database product.
        
        @return database product name
        @exception SQLException if a database access error occurs
        """
        return 'SAP DB'
    # end getDatabaseProductName

    def getDatabaseProductVersion (self):
        """
        Retrieves the version number of this database product.
        
        @return database version number
        @exception SQLException if a database access error occurs
        """
        pass
    # end getDatabaseProductVersion
    del getDatabaseProductVersion

    def getDefaultTransactionIsolation (self):
        """
        Retrieves this database's default transaction isolation level.  The
        possible values are defined in <code>java.sql.Connection</code>.
        
        @return the default isolation level 
        @exception SQLException if a database access error occurs
        @see Connection
        """
        return 2
    # end getDefaultTransactionIsolation

    def getDriverMajorVersion (self):
        """
        Retrieves this JDBC driver's major version number.
        
        @return JDBC driver major version
        """
        pass
    # end getDriverMajorVersion
    del getDriverMajorVersion

    def getDriverMinorVersion (self):
        """
        Retrieves this JDBC driver's minor version number.
        
        @return JDBC driver minor version number
        """
        pass
    # end getDriverMinorVersion
    del getDriverMinorVersion

    def getDriverName (self):
        """
        Retrieves the name of this JDBC driver.
        
        @return JDBC driver name
        @exception SQLException if a database access error occurs
        """
        pass
    # end getDriverName
    del getDriverName

    def getDriverVersion (self):
        """
        Retrieves the version number of this JDBC driver as a <code>String</code>.
        
        @return JDBC driver version
        @exception SQLException if a database access error occurs
        """
        pass
    # end getDriverVersion
    del getDriverVersion

    def getExportedKeys (self, catalog, schema, table):
        """
        Retrieves a description of the foreign key columns that reference the
        given table's primary key columns (the foreign keys exported by a
        table).  They are ordered by FKTABLE_CAT, FKTABLE_SCHEM,
        FKTABLE_NAME, and KEY_SEQ.
        
        <P>Each foreign key column description has the following columns:
        <OL>
        <LI><B>PKTABLE_CAT</B> String => primary key table catalog (may be <code>null</code>)
        <LI><B>PKTABLE_SCHEM</B> String => primary key table schema (may be <code>null</code>)
        <LI><B>PKTABLE_NAME</B> String => primary key table name
        <LI><B>PKCOLUMN_NAME</B> String => primary key column name
        <LI><B>FKTABLE_CAT</B> String => foreign key table catalog (may be <code>null</code>)
        being exported (may be <code>null</code>)
        <LI><B>FKTABLE_SCHEM</B> String => foreign key table schema (may be <code>null</code>)
        being exported (may be <code>null</code>)
        <LI><B>FKTABLE_NAME</B> String => foreign key table name
        being exported
        <LI><B>FKCOLUMN_NAME</B> String => foreign key column name
        being exported
        <LI><B>KEY_SEQ</B> short => sequence number within foreign key
        <LI><B>UPDATE_RULE</B> short => What happens to 
        foreign key when primary is updated:
        <UL>
        <LI> importedNoAction - do not allow update of primary 
        key if it has been imported
        <LI> importedKeyCascade - change imported key to agree 
        with primary key update
        <LI> importedKeySetNull - change imported key to <code>NULL</code> if 
        its primary key has been updated
        <LI> importedKeySetDefault - change imported key to default values 
        if its primary key has been updated
        <LI> importedKeyRestrict - same as importedKeyNoAction 
        (for ODBC 2.x compatibility)
        </UL>
        <LI><B>DELETE_RULE</B> short => What happens to 
        the foreign key when primary is deleted.
        <UL>
        <LI> importedKeyNoAction - do not allow delete of primary 
        key if it has been imported
        <LI> importedKeyCascade - delete rows that import a deleted key
        <LI> importedKeySetNull - change imported key to <code>NULL</code> if 
        its primary key has been deleted
        <LI> importedKeyRestrict - same as importedKeyNoAction 
        (for ODBC 2.x compatibility)
        <LI> importedKeySetDefault - change imported key to default if 
        its primary key has been deleted
        </UL>
        <LI><B>FK_NAME</B> String => foreign key name (may be <code>null</code>)
        <LI><B>PK_NAME</B> String => primary key name (may be <code>null</code>)
        <LI><B>DEFERRABILITY</B> short => can the evaluation of foreign key 
        constraints be deferred until commit
        <UL>
        <LI> importedKeyInitiallyDeferred - see SQL92 for definition
        <LI> importedKeyInitiallyImmediate - see SQL92 for definition 
        <LI> importedKeyNotDeferrable - see SQL92 for definition 
        </UL>
        </OL>
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in this database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schema a schema name; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param table a table name; must match the table name as it is stored 
        in this database 
        @return a <code>ResultSet</code> object in which each row is a 
        foreign key column description 
        @exception SQLException if a database access error occurs
        @see #getImportedKeys 
        """
        pass
    # end getExportedKeys
    del getExportedKeys

    def getExtraNameCharacters (self):
        """
        Retrieves all the "extra" characters that can be used in unquoted
        identifier names (those beyond a-z, A-Z, 0-9 and _).
        
        @return the string containing the extra characters 
        @exception SQLException if a database access error occurs
        """
        return '#@$'
    # end getExtraNameCharacters

    def getIdentifierQuoteString (self):
        """
        Retrieves the string used to quote SQL identifiers.
        This method returns a space " " if identifier quoting is not supported.
        
        @return the quoting string or a space if quoting is not supported
        @exception SQLException if a database access error occurs
        """
        return '"'
    # end getIdentifierQuoteString

    def getImportedKeys (self, catalog, schema, table):
        """
        Retrieves a description of the primary key columns that are
        referenced by a table's foreign key columns (the primary keys
        imported by a table).  They are ordered by PKTABLE_CAT,
        PKTABLE_SCHEM, PKTABLE_NAME, and KEY_SEQ.
        
        <P>Each primary key column description has the following columns:
        <OL>
        <LI><B>PKTABLE_CAT</B> String => primary key table catalog 
        being imported (may be <code>null</code>)
        <LI><B>PKTABLE_SCHEM</B> String => primary key table schema
        being imported (may be <code>null</code>)
        <LI><B>PKTABLE_NAME</B> String => primary key table name
        being imported
        <LI><B>PKCOLUMN_NAME</B> String => primary key column name
        being imported
        <LI><B>FKTABLE_CAT</B> String => foreign key table catalog (may be <code>null</code>)
        <LI><B>FKTABLE_SCHEM</B> String => foreign key table schema (may be <code>null</code>)
        <LI><B>FKTABLE_NAME</B> String => foreign key table name
        <LI><B>FKCOLUMN_NAME</B> String => foreign key column name
        <LI><B>KEY_SEQ</B> short => sequence number within a foreign key
        <LI><B>UPDATE_RULE</B> short => What happens to a
        foreign key when the primary key is updated:
        <UL>
        <LI> importedNoAction - do not allow update of primary 
        key if it has been imported
        <LI> importedKeyCascade - change imported key to agree 
        with primary key update
        <LI> importedKeySetNull - change imported key to <code>NULL</code>
        if its primary key has been updated
        <LI> importedKeySetDefault - change imported key to default values 
        if its primary key has been updated
        <LI> importedKeyRestrict - same as importedKeyNoAction 
        (for ODBC 2.x compatibility)
        </UL>
        <LI><B>DELETE_RULE</B> short => What happens to 
        the foreign key when primary is deleted.
        <UL>
        <LI> importedKeyNoAction - do not allow delete of primary 
        key if it has been imported
        <LI> importedKeyCascade - delete rows that import a deleted key
        <LI> importedKeySetNull - change imported key to NULL if 
        its primary key has been deleted
        <LI> importedKeyRestrict - same as importedKeyNoAction 
        (for ODBC 2.x compatibility)
        <LI> importedKeySetDefault - change imported key to default if 
        its primary key has been deleted
        </UL>
        <LI><B>FK_NAME</B> String => foreign key name (may be <code>null</code>)
        <LI><B>PK_NAME</B> String => primary key name (may be <code>null</code>)
        <LI><B>DEFERRABILITY</B> short => can the evaluation of foreign key 
        constraints be deferred until commit
        <UL>
        <LI> importedKeyInitiallyDeferred - see SQL92 for definition
        <LI> importedKeyInitiallyImmediate - see SQL92 for definition 
        <LI> importedKeyNotDeferrable - see SQL92 for definition 
        </UL>
        </OL>
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schema a schema name; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param table a table name; must match the table name as it is stored 
        in the database 
        @return <code>ResultSet</code> - each row is a primary key column description 
        @exception SQLException if a database access error occurs
        @see #getExportedKeys 
        """
        pass
    # end getImportedKeys
    del getImportedKeys

    def getIndexInfo (self, catalog, schema, table, unique, approximate):
        """
        Retrieves a description of the given table's indices and statistics. They are
        ordered by NON_UNIQUE, TYPE, INDEX_NAME, and ORDINAL_POSITION.
        
        <P>Each index column description has the following columns:
        <OL>
        <LI><B>TABLE_CAT</B> String => table catalog (may be <code>null</code>)
        <LI><B>TABLE_SCHEM</B> String => table schema (may be <code>null</code>)
        <LI><B>TABLE_NAME</B> String => table name
        <LI><B>NON_UNIQUE</B> boolean => Can index values be non-unique. 
        false when TYPE is tableIndexStatistic
        <LI><B>INDEX_QUALIFIER</B> String => index catalog (may be <code>null</code>); 
        <code>null</code> when TYPE is tableIndexStatistic
        <LI><B>INDEX_NAME</B> String => index name; <code>null</code> when TYPE is 
        tableIndexStatistic
        <LI><B>TYPE</B> short => index type:
        <UL>
        <LI> tableIndexStatistic - this identifies table statistics that are
        returned in conjuction with a table's index descriptions
        <LI> tableIndexClustered - this is a clustered index
        <LI> tableIndexHashed - this is a hashed index
        <LI> tableIndexOther - this is some other style of index
        </UL>
        <LI><B>ORDINAL_POSITION</B> short => column sequence number 
        within index; zero when TYPE is tableIndexStatistic
        <LI><B>COLUMN_NAME</B> String => column name; <code>null</code> when TYPE is 
        tableIndexStatistic
        <LI><B>ASC_OR_DESC</B> String => column sort sequence, "A" => ascending, 
        "D" => descending, may be <code>null</code> if sort sequence is not supported; 
        <code>null</code> when TYPE is tableIndexStatistic	
        <LI><B>CARDINALITY</B> int => When TYPE is tableIndexStatistic, then 
        this is the number of rows in the table; otherwise, it is the 
        number of unique values in the index.
        <LI><B>PAGES</B> int => When TYPE is  tableIndexStatisic then 
        this is the number of pages used for the table, otherwise it 
        is the number of pages used for the current index.
        <LI><B>FILTER_CONDITION</B> String => Filter condition, if any.  
        (may be <code>null</code>)
        </OL>
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in this database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schema a schema name; must match the schema name
        as it is stored in this database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param table a table name; must match the table name as it is stored 
        in this database 
        @param unique when true, return only indices for unique values; 
        when false, return indices regardless of whether unique or not 
        @param approximate when true, result is allowed to reflect approximate 
        or out of data values; when false, results are requested to be 
        accurate
        @return <code>ResultSet</code> - each row is an index column description 
        @exception SQLException if a database access error occurs
        """
        pass
    # end getIndexInfo
    del getIndexInfo

    def getJDBCMajorVersion (self):
        """
        Retrieves the major JDBC version number for this
        driver.
        
        @return JDBC version major number
        @exception SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end getJDBCMajorVersion
    del getJDBCMajorVersion

    def getJDBCMinorVersion (self):
        """
        Retrieves the minor JDBC version number for this
        driver.
        
        @return JDBC version minor number
        @exception SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end getJDBCMinorVersion
    del getJDBCMinorVersion

    def getMaxBinaryLiteralLength (self):
        """
        Retrieves the maximum number of hex characters this database allows in an 
        inline binary literal.
        
        @return max the maximum length (in hex characters) for a binary literal;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 8000
    # end getMaxBinaryLiteralLength

    def getMaxCatalogNameLength (self):
        """
        Retrieves the maximum number of characters that this database allows in a
        catalog name.
        
        @return the maximum number of characters allowed in a catalog name;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 0
    # end getMaxCatalogNameLength

    def getMaxCharLiteralLength (self):
        """
        Retrieves the maximum number of characters this database allows 
        for a character literal.
        
        @return the maximum number of characters allowed for a character literal;
        a result of zero means that there is no limit or the limit is 
        not known
        @exception SQLException if a database access error occurs
        """
        return 4000
    # end getMaxCharLiteralLength

    def getMaxColumnNameLength (self):
        """
        Retrieves the maximum number of characters this database allows
        for a column name.
        
        @return the maximum number of characters allowed for a column name;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 32
    # end getMaxColumnNameLength

    def getMaxColumnsInGroupBy (self):
        """
        Retrieves the maximum number of columns this database allows in a 
        <code>GROUP BY</code> clause.
        
        @return the maximum number of columns allowed;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 16
    # end getMaxColumnsInGroupBy

    def getMaxColumnsInIndex (self):
        """
        Retrieves the maximum number of columns this database allows in an index.
        
        @return the maximum number of columns allowed;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 16
    # end getMaxColumnsInIndex

    def getMaxColumnsInOrderBy (self):
        """
        Retrieves the maximum number of columns this database allows in an 
        <code>ORDER BY</code> clause.
        
        @return the maximum number of columns allowed;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 16
    # end getMaxColumnsInOrderBy

    def getMaxColumnsInSelect (self):
        """
        Retrieves the maximum number of columns this database allows in a 
        <code>SELECT</code> list.
        
        @return the maximum number of columns allowed;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 254
    # end getMaxColumnsInSelect

    def getMaxColumnsInTable (self):
        """
        Retrieves the maximum number of columns this database allows in a table.
        
        @return the maximum number of columns allowed;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 254
    # end getMaxColumnsInTable

    def getMaxConnections (self):
        """
        Retrieves the maximum number of concurrent connections to this
        database that are possible.
        
        @return the maximum number of active connections possible at one time;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return -1
    # end getMaxConnections

    def getMaxCursorNameLength (self):
        """
        Retrieves the maximum number of characters that this database allows in a
        cursor name.
        
        @return the maximum number of characters allowed in a cursor name;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 32
    # end getMaxCursorNameLength

    def getMaxIndexLength (self):
        """
        Retrieves the maximum number of bytes this database allows for an 
        index, including all of the parts of the index.
        
        @return the maximum number of bytes allowed; this limit includes the 
        composite of all the constituent parts of the index;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 0
    # end getMaxIndexLength

    def getMaxProcedureNameLength (self):
        """
        Retrieves the maximum number of characters that this database allows in a
        procedure name.
        
        @return the maximum number of characters allowed in a procedure name;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 32
    # end getMaxProcedureNameLength

    def getMaxRowSize (self):
        """
        Retrieves the maximum number of bytes this database allows in
        a single row.
        
        @return the maximum number of bytes allowed for a row; a result of 
        zero means that there is no limit or the limit is not known
        @exception SQLException if a database access error occurs
        """
        return 0
    # end getMaxRowSize

    def getMaxSchemaNameLength (self):
        """
        Retrieves the maximum number of characters that this database allows in a
        schema name.
        
        @return the maximum number of characters allowed in a schema name;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 32
    # end getMaxSchemaNameLength

    def getMaxStatementLength (self):
        """
        Retrieves the maximum number of characters this database allows in
        an SQL statement.
        
        @return the maximum number of characters allowed for an SQL statement;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 28136
    # end getMaxStatementLength

    def getMaxStatements (self):
        """
        Retrieves the maximum number of active statements to this database
        that can be open at the same time.
        
        @return the maximum number of statements that can be open at one time;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 2147483647
    # end getMaxStatements

    def getMaxTableNameLength (self):
        """
        Retrieves the maximum number of characters this database allows in
        a table name.
        
        @return the maximum number of characters allowed for a table name;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 32
    # end getMaxTableNameLength

    def getMaxTablesInSelect (self):
        """
        Retrieves the maximum number of tables this database allows in a
        <code>SELECT</code> statement.
        
        @return the maximum number of tables allowed in a <code>SELECT</code> 
        statement; a result of zero means that there is no limit or 
        the limit is not known
        @exception SQLException if a database access error occurs
        """
        return 16
    # end getMaxTablesInSelect

    def getMaxUserNameLength (self):
        """
        Retrieves the maximum number of characters this database allows in
        a user name.
        
        @return the maximum number of characters allowed for a user name;
        a result of zero means that there is no limit or the limit 
        is not known
        @exception SQLException if a database access error occurs
        """
        return 32
    # end getMaxUserNameLength

    def getNumericFunctions (self):
        """
        Retrieves a comma-separated list of math functions available with
        this database.  These are the Open /Open CLI math function names used in 
        the JDBC function escape clause.
        
        @return the list of math functions supported by this database
        @exception SQLException if a database access error occurs
        """
        return 'ABS,ACOS,ASIN,ATAN,ATAN2,CEILING,COS,COT,DEGREES,EXP,FLOOR,LOG,MOD,PI,POWER,RADIANS,ROUND,RAND,SIGN,SIN,SQRT,TAN,TRUNCATE'
    # end getNumericFunctions

    def getPrimaryKeys (self, catalog, schema, table):
        """
        Retrieves a description of the given table's primary key columns.  They
        are ordered by COLUMN_NAME.
        
        <P>Each primary key column description has the following columns:
        <OL>
        <LI><B>TABLE_CAT</B> String => table catalog (may be <code>null</code>)
        <LI><B>TABLE_SCHEM</B> String => table schema (may be <code>null</code>)
        <LI><B>TABLE_NAME</B> String => table name
        <LI><B>COLUMN_NAME</B> String => column name
        <LI><B>KEY_SEQ</B> short => sequence number within primary key
        <LI><B>PK_NAME</B> String => primary key name (may be <code>null</code>)
        </OL>
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schema a schema name; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param table a table name; must match the table name as it is stored 
        in the database 
        @return <code>ResultSet</code> - each row is a primary key column description 
        @exception SQLException if a database access error occurs
        """
        pass
    # end getPrimaryKeys
    del getPrimaryKeys

    def getProcedureColumns (self, catalog, schemaPattern, procedureNamePattern, columnNamePattern):
        """
        Retrieves a description of the given catalog's stored procedure parameter
        and result columns.
        
        <P>Only descriptions matching the schema, procedure and
        parameter name criteria are returned.  They are ordered by
        PROCEDURE_SCHEM and PROCEDURE_NAME. Within this, the return value,
        if any, is first. Next are the parameter descriptions in call
        order. The column descriptions follow in column number order.
        
        <P>Each row in the <code>ResultSet</code> is a parameter description or
        column description with the following fields:
        <OL>
        <LI><B>PROCEDURE_CAT</B> String => procedure catalog (may be <code>null</code>)
        <LI><B>PROCEDURE_SCHEM</B> String => procedure schema (may be <code>null</code>)
        <LI><B>PROCEDURE_NAME</B> String => procedure name
        <LI><B>COLUMN_NAME</B> String => column/parameter name 
        <LI><B>COLUMN_TYPE</B> Short => kind of column/parameter:
        <UL>
        <LI> procedureColumnUnknown - nobody knows
        <LI> procedureColumnIn - IN parameter
        <LI> procedureColumnInOut - INOUT parameter
        <LI> procedureColumnOut - OUT parameter
        <LI> procedureColumnReturn - procedure return value
        <LI> procedureColumnResult - result column in <code>ResultSet</code>
        </UL>
        <LI><B>DATA_TYPE</B> short => SQL type from java.sql.Types
        <LI><B>TYPE_NAME</B> String => SQL type name, for a UDT type the
        type name is fully qualified
        <LI><B>PRECISION</B> int => precision
        <LI><B>LENGTH</B> int => length in bytes of data
        <LI><B>SCALE</B> short => scale
        <LI><B>RADIX</B> short => radix
        <LI><B>NULLABLE</B> short => can it contain NULL.
        <UL>
        <LI> procedureNoNulls - does not allow NULL values
        <LI> procedureNullable - allows NULL values
        <LI> procedureNullableUnknown - nullability unknown
        </UL>
        <LI><B>REMARKS</B> String => comment describing parameter/column
        </OL>
        
        <P><B>Note:</B> Some databases may not return the column
        descriptions for a procedure. Additional columns beyond
        REMARKS can be defined by the database.
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schemaPattern a schema name pattern; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param procedureNamePattern a procedure name pattern; must match the
        procedure name as it is stored in the database 
        @param columnNamePattern a column name pattern; must match the column name
        as it is stored in the database 
        @return <code>ResultSet</code> - each row describes a stored procedure parameter or 
        column
        @exception SQLException if a database access error occurs
        @see #getSearchStringEscape 
        """
        pass
    # end getProcedureColumns
    del getProcedureColumns

    def getProcedureTerm (self):
        """
        Retrieves the database vendor's preferred term for "procedure".
        
        @return the vendor term for "procedure"
        @exception SQLException if a database access error occurs
        """
        return 'StoredProcedure'
    # end getProcedureTerm

    def getProcedures (self, catalog, schemaPattern, procedureNamePattern):
        """
        Retrieves a description of the stored procedures available in the given
        catalog.
        <P>
        Only procedure descriptions matching the schema and
        procedure name criteria are returned.  They are ordered by
        <code>PROCEDURE_SCHEM</code> and <code>PROCEDURE_NAME</code>.
        
        <P>Each procedure description has the the following columns:
        <OL>
        <LI><B>PROCEDURE_CAT</B> String => procedure catalog (may be <code>null</code>)
        <LI><B>PROCEDURE_SCHEM</B> String => procedure schema (may be <code>null</code>)
        <LI><B>PROCEDURE_NAME</B> String => procedure name
        <LI> reserved for future use
        <LI> reserved for future use
        <LI> reserved for future use
        <LI><B>REMARKS</B> String => explanatory comment on the procedure
        <LI><B>PROCEDURE_TYPE</B> short => kind of procedure:
        <UL>
        <LI> procedureResultUnknown - May return a result
        <LI> procedureNoResult - Does not return a result
        <LI> procedureReturnsResult - Returns a result
        </UL>
        </OL>
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schemaPattern a schema name pattern; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param procedureNamePattern a procedure name pattern; must match the
        procedure name as it is stored in the database 
        @return <code>ResultSet</code> - each row is a procedure description 
        @exception SQLException if a database access error occurs
        @see #getSearchStringEscape 
        """
        pass
    # end getProcedures
    del getProcedures

    def getResultSetHoldability (self):
        """
        Retrieves the default holdability of this <code>ResultSet</code>
        object.
        
        @return the default holdability; either 
        <code>ResultSet.HOLD_CURSORS_OVER_COMMIT</code> or
        <code>ResultSet.CLOSE_CURSORS_AT_COMMIT</code>
        @exception SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end getResultSetHoldability
    del getResultSetHoldability

    def getSQLKeywords (self):
        """
        Retrieves a comma-separated list of all of this database's SQL keywords
        that are NOT also SQL92 keywords.
        
        @return the list of this database's keywords that are not also
        SQL92 keywords
        @exception SQLException if a database access error occurs
        """
        return 'ABS,ACOS,ADDDATE,ADDTIME,ALPHA,ASCII,ASIN,ATAN,ATAN2,BINARY,BOOLEAN,BYTE,CEIL,CEILING,CHR,CONCAT,CONNECTED,COS,COSH,COT,CURDATE,CURTIME,DATABASE,DATEDIFF,DAYNAME,DAYOFMONTH,DAYOFWEEK,DAYOFYEAR,DBYTE,DECODE,DEFAULT,DEGREES,DIGITS,DIRECT,EBCDIC,ENTRY,ENTRYDEF,EXP,EXPAND,FIXED,FLOOR,GRAPHIC,GREATEST,HEX,IFNULL,INITCAP,INT,INTERNAL,LCASE,LEAST,LENGTH,LFILL,LINK,LIST,LN,LOCALSYSDBA,LOCATE,LOG,LOG10,LONG,LPAD,LTRIM,MAKEDATE,MAKETIME,MAPCHAR,MBCS,MICROSECOND,MOD,MONTHNAME,NOROUND,NOW,NUM,OBJECT,PACKED,PI,POWER,PREV,RADIANS,REAL,REFERENCED,REJECT,REPLACE,RFILL,ROUND,ROWID,ROWNO,RPAD,RTRIM,SELUPD,SHOW,SIGN,SIN,SINH,SOUNDEX,SPACE,SQRT,STAMP,STATISTICS,STDDEV,SUBDATE,SUBSTR,SUBTIME,SYSDBA,TAN,TANH,TIMEDIFF,TIMEZONE,TOIDENTIFIER,TRIM,TRUNC,TRUNCATE,UCASE,UNICODE,USERGROUP,VARGRAPHIC,VARIANCE,WEEK,WEEKOFYEAR,ZONED'
    # end getSQLKeywords

    def getSQLStateType (self):
        """
        Indicates whether the SQLSTATEs returned by <code>SQLException.getSQLState</code>
        is X/Open (now known as Open Group) SQL CLI or SQL99.
        @return the type of SQLSTATEs, one of:
        sqlStateXOpen or
        sqlStateSQL99
        @throws SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end getSQLStateType
    del getSQLStateType

    def getSchemaTerm (self):
        """
        Retrieves the database vendor's preferred term for "schema".
        
        @return the vendor term for "schema"
        @exception SQLException if a database access error occurs
        """
        return 'SCHEM'
    # end getSchemaTerm

    def getSchemas (self):
        """
        Retrieves the schema names available in this database.  The results
        are ordered by schema name.
        
        <P>The schema column is:
        <OL>
        <LI><B>TABLE_SCHEM</B> String => schema name
        <LI><B>TABLE_CATALOG</B> String => catalog name (may be <code>null</code>)
        </OL>
        
        @return a <code>ResultSet</code> object in which each row is a 
        schema decription 
        @exception SQLException if a database access error occurs
        """
        pass
    # end getSchemas
    del getSchemas

    def getSearchStringEscape (self):
        """
        Retrieves the string that can be used to escape wildcard characters.
        This is the string that can be used to escape '_' or '%' in
        the catalog search parameters that are a pattern (and therefore use one
        of the wildcard characters).
        
        <P>The '_' character represents any single character;
        the '%' character represents any sequence of zero or 
        more characters.
        
        @return the string used to escape wildcard characters
        @exception SQLException if a database access error occurs
        """
        return '\\'
    # end getSearchStringEscape

    def getStringFunctions (self):
        """
        Retrieves a comma-separated list of string functions available with
        this database.  These are the  Open Group CLI string function names used 
        in the JDBC function escape clause.
        
        @return the list of string functions supported by this database 
        @exception SQLException if a database access error occurs
        """
        return 'ASCII,CHAR,CONCAT,DIFFERENCE,INSERT,LCASE,LEFT,LENGTH,LOCATE,LOCATE_2,LTRIM,REPEAT,REPLACE,RIGHT,RTRIM,SOUNDEX,SPACE,SUBSTRING,UCASE'
    # end getStringFunctions

    def getSuperTables (self, catalog, schemaPattern, tableNamePattern):
        """
        Retrieves a description of the table hierarchies defined in a particular 
        schema in this database.
        
        <P>Only supertable information for tables matching the catalog, schema
        and table name are returned. The table name parameter may be a fully-
        qualified name, in which case, the catalog and schemaPattern parameters
        are ignored. If a table does not have a super table, it is not listed here.
        Supertables have to be defined in the same catalog and schema as the 
        sub tables. Therefore, the type description does not need to include
        this information for the supertable.
        
        <P>Each type description has the following columns:
        <OL>
        <LI><B>TABLE_CAT</B> String => the type's catalog (may be <code>null</code>)
        <LI><B>TABLE_SCHEM</B> String => type's schema (may be <code>null</code>)
        <LI><B>TABLE_NAME</B> String => type name
        <LI><B>SUPERTABLE_NAME</B> String => the direct super type's name
        </OL>
        
        <P><B>Note:</B> If the driver does not support type hierarchies, an 
        empty result set is returned.
        
        @param catalog a catalog name; "" retrieves those without a catalog;
        <code>null</code> means drop catalog name from the selection criteria
        @param schemaPattern a schema name pattern; "" retrieves those 
        without a schema
        @param tableNamePattern a table name pattern; may be a fully-qualified
        name
        @return a <code>ResultSet</code> object in which each row is a type description
        @throws SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end getSuperTables
    del getSuperTables

    def getSuperTypes (self, catalog, schemaPattern, typeNamePattern):
        """
        Retrieves a description of the user-defined type (UDT) hierarchies defined in a 
        particular schema in this database. Only the immediate super type/ 
        sub type relationship is modeled.
        <P>
        Only supertype information for UDTs matching the catalog, 
        schema, and type name is returned. The type name parameter
        may be a fully-qualified name. When the UDT name supplied is a 
        fully-qualified name, the catalog and schemaPattern parameters are 
        ignored. 
        <P>
        If a UDT does not have a direct super type, it is not listed here.
        A row of the <code>ResultSet</code> object returned by this method
        describes the designated UDT and a direct supertype. A row has the following 
        columns:
        <OL>
        <LI><B>TYPE_CAT</B> String => the UDT's catalog (may be <code>null</code>)
        <LI><B>TYPE_SCHEM</B> String => UDT's schema (may be <code>null</code>)
        <LI><B>TYPE_NAME</B> String => type name of the UDT
        <LI><B>SUPERTYPE_CAT</B> String => the direct super type's catalog 
        (may be <code>null</code>)
        <LI><B>SUPERTYPE_SCHEM</B> String => the direct super type's schema 
        (may be <code>null</code>)
        <LI><B>SUPERTYPE_NAME</B> String => the direct super type's name
        </OL>
        
        <P><B>Note:</B> If the driver does not support type hierarchies, an 
        empty result set is returned.
        
        @param catalog a catalog name; "" retrieves those without a catalog;
        <code>null</code> means drop catalog name from the selection criteria
        @param schemaPattern a schema name pattern; "" retrieves those 
        without a schema
        @param typeNamePattern a UDT name pattern; may be a fully-qualified
        name
        @return a <code>ResultSet</code> object in which a row gives information
        about the designated UDT
        @throws SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end getSuperTypes
    del getSuperTypes

    def getSystemFunctions (self):
        """
        Retrieves a comma-separated list of system functions available with
        this database.  These are the  Open Group CLI system function names used 
        in the JDBC function escape clause.
        
        @return a list of system functions supported by this database
        @exception SQLException if a database access error occurs
        """
        return 'DBNAME,IFNULL,USERNAME'
    # end getSystemFunctions

    def getTablePrivileges (self, catalog, schemaPattern, tableNamePattern):
        """
        Retrieves a description of the access rights for each table available
        in a catalog. Note that a table privilege applies to one or
        more columns in the table. It would be wrong to assume that
        this privilege applies to all columns (this may be true for
        some systems but is not true for all.)
        
        <P>Only privileges matching the schema and table name
        criteria are returned.  They are ordered by TABLE_SCHEM,
        TABLE_NAME, and PRIVILEGE.
        
        <P>Each privilige description has the following columns:
        <OL>
        <LI><B>TABLE_CAT</B> String => table catalog (may be <code>null</code>)
        <LI><B>TABLE_SCHEM</B> String => table schema (may be <code>null</code>)
        <LI><B>TABLE_NAME</B> String => table name
        <LI><B>GRANTOR</B> => grantor of access (may be <code>null</code>)
        <LI><B>GRANTEE</B> String => grantee of access
        <LI><B>PRIVILEGE</B> String => name of access (SELECT, 
        INSERT, UPDATE, REFRENCES, ...)
        <LI><B>IS_GRANTABLE</B> String => "YES" if grantee is permitted 
        to grant to others; "NO" if not; <code>null</code> if unknown 
        </OL>
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schemaPattern a schema name pattern; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param tableNamePattern a table name pattern; must match the
        table name as it is stored in the database 
        @return <code>ResultSet</code> - each row is a table privilege description
        @exception SQLException if a database access error occurs
        @see #getSearchStringEscape 
        """
        pass
    # end getTablePrivileges
    del getTablePrivileges

    def getTableTypes (self):
        """
        Retrieves the table types available in this database.  The results
        are ordered by table type.
        
        <P>The table type is:
        <OL>
        <LI><B>TABLE_TYPE</B> String => table type.  Typical types are "TABLE",
        "VIEW",	"SYSTEM TABLE", "GLOBAL TEMPORARY", 
        "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
        </OL>
        
        @return a <code>ResultSet</code> object in which each row has a 
        single <code>String</code> column that is a table type 
        @exception SQLException if a database access error occurs
        """
        pass
    # end getTableTypes
    del getTableTypes

    def getTables (self, catalog, schemaPattern, tableNamePattern, types):
        """
        Retrieves a description of the tables available in the given catalog.
        Only table descriptions matching the catalog, schema, table
        name and type criteria are returned.  They are ordered by
        TABLE_TYPE, TABLE_SCHEM and TABLE_NAME.
        <P>
        Each table description has the following columns:
        <OL>
        <LI><B>TABLE_CAT</B> String => table catalog (may be <code>null</code>)
        <LI><B>TABLE_SCHEM</B> String => table schema (may be <code>null</code>)
        <LI><B>TABLE_NAME</B> String => table name
        <LI><B>TABLE_TYPE</B> String => table type.  Typical types are "TABLE",
        "VIEW",	"SYSTEM TABLE", "GLOBAL TEMPORARY", 
        "LOCAL TEMPORARY", "ALIAS", "SYNONYM".
        <LI><B>REMARKS</B> String => explanatory comment on the table
        <LI><B>TYPE_CAT</B> String => the types catalog (may be <code>null</code>)
        <LI><B>TYPE_SCHEM</B> String => the types schema (may be <code>null</code>)
        <LI><B>TYPE_NAME</B> String => type name (may be <code>null</code>)
        <LI><B>SELF_REFERENCING_COL_NAME</B> String => name of the designated 
        "identifier" column of a typed table (may be <code>null</code>)
        <LI><B>REF_GENERATION</B> String => specifies how values in 
        SELF_REFERENCING_COL_NAME are created. Values are
        "SYSTEM", "USER", "DERIVED". (may be <code>null</code>)	
        </OL>
        
        <P><B>Note:</B> Some databases may not return information for
        all tables.
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schemaPattern a schema name pattern; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param tableNamePattern a table name pattern; must match the
        table name as it is stored in the database 
        @param types a list of table types to include; <code>null</code> returns all types 
        @return <code>ResultSet</code> - each row is a table description
        @exception SQLException if a database access error occurs
        @see #getSearchStringEscape 
        """
        pass
    # end getTables
    del getTables

    def getTimeDateFunctions (self):
        """
        Retrieves a comma-separated list of the time and date functions available 
        with this database.
        
        @return the list of time and date functions supported by this database
        @exception SQLException if a database access error occurs
        """
        return 'CURDATE,CURTIME,DAYNAME,DAYOFMONTH,DAYOFWEEK,DAYOFYEAR,HOUR,MINUTE,MONTH,MONTHNAME,NOW,QUARTER,SECOND,TIMESTAMPADD,TIMESTAMPDIFF,WEEK,YEAR'
    # end getTimeDateFunctions

    def getTypeInfo (self):
        """
        Retrieves a description of all the standard SQL types supported by
        this database. They are ordered by DATA_TYPE and then by how
        closely the data type maps to the corresponding JDBC SQL type.
        
        <P>Each type description has the following columns:
        <OL>
        <LI><B>TYPE_NAME</B> String => Type name
        <LI><B>DATA_TYPE</B> short => SQL data type from java.sql.Types
        <LI><B>PRECISION</B> int => maximum precision
        <LI><B>LITERAL_PREFIX</B> String => prefix used to quote a literal 
        (may be <code>null</code>)
        <LI><B>LITERAL_SUFFIX</B> String => suffix used to quote a literal 
             (may be <code>null</code>)
        <LI><B>CREATE_PARAMS</B> String => parameters used in creating 
        the type (may be <code>null</code>)
        <LI><B>NULLABLE</B> short => can you use NULL for this type.
        <UL>
        <LI> typeNoNulls - does not allow NULL values
        <LI> typeNullable - allows NULL values
        <LI> typeNullableUnknown - nullability unknown
        </UL>
        <LI><B>CASE_SENSITIVE</B> boolean=> is it case sensitive.
        <LI><B>SEARCHABLE</B> short => can you use "WHERE" based on this type:
        <UL>
        <LI> typePredNone - No support
        <LI> typePredChar - Only supported with WHERE .. LIKE
        <LI> typePredBasic - Supported except for WHERE .. LIKE
        <LI> typeSearchable - Supported for all WHERE ..
        </UL>
        <LI><B>UNSIGNED_ATTRIBUTE</B> boolean => is it unsigned.
        <LI><B>FIXED_PREC_SCALE</B> boolean => can it be a money value.
        <LI><B>AUTO_INCREMENT</B> boolean => can it be used for an 
        auto-increment value.
        <LI><B>LOCAL_TYPE_NAME</B> String => localized version of type name 
        (may be <code>null</code>)
        <LI><B>MINIMUM_SCALE</B> short => minimum scale supported
        <LI><B>MAXIMUM_SCALE</B> short => maximum scale supported
        <LI><B>SQL_DATA_TYPE</B> int => unused
        <LI><B>SQL_DATETIME_SUB</B> int => unused
        <LI><B>NUM_PREC_RADIX</B> int => usually 2 or 10
        </OL>
        
        @return a <code>ResultSet</code> object in which each row is an SQL 
        type description 
        @exception SQLException if a database access error occurs
        """
        pass
    # end getTypeInfo
    del getTypeInfo

    def getUDTs (self, catalog, schemaPattern, typeNamePattern, types):
        """
        Retrieves a description of the user-defined types (UDTs) defined 
        in a particular schema.  Schema-specific UDTs may have type 
        <code>JAVA_OBJECT</code>, <code>STRUCT</code>, 
        or <code>DISTINCT</code>.
        
        <P>Only types matching the catalog, schema, type name and type  
        criteria are returned.  They are ordered by DATA_TYPE, TYPE_SCHEM 
        and TYPE_NAME.  The type name parameter may be a fully-qualified 
        name.  In this case, the catalog and schemaPattern parameters are
        ignored.
        
        <P>Each type description has the following columns:
        <OL>
        <LI><B>TYPE_CAT</B> String => the type's catalog (may be <code>null</code>)
        <LI><B>TYPE_SCHEM</B> String => type's schema (may be <code>null</code>)
        <LI><B>TYPE_NAME</B> String => type name
        <LI><B>CLASS_NAME</B> String => Java class name
        <LI><B>DATA_TYPE</B> String => type value defined in java.sql.Types.  
        One of JAVA_OBJECT, STRUCT, or DISTINCT
        <LI><B>REMARKS</B> String => explanatory comment on the type
        <LI><B>BASE_TYPE</B> short => type code of the source type of a 
        DISTINCT type or the type that implements the user-generated
        reference type of the SELF_REFERENCING_COLUMN of a structured
        type as defined in java.sql.Types (<code>null</code> if DATA_TYPE is not
        DISTINCT or not STRUCT with REFERENCE_GENERATION = USER_DEFINED) 
        </OL>
        
        <P><B>Note:</B> If the driver does not support UDTs, an empty
        result set is returned.
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schemaPattern a schema pattern name; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param typeNamePattern a type name pattern; must match the type name
        as it is stored in the database; may be a fully qualified name 
        @param types a list of user-defined types (JAVA_OBJECT, 
        STRUCT, or DISTINCT) to include; <code>null</code> returns all types 
        @return <code>ResultSet</code> object in which each row describes a UDT
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end getUDTs
    del getUDTs

    def getURL (self):
        """
        Retrieves the URL for this DBMS.
        
        @return the URL for this DBMS or <code>null</code> if it cannot be 
        generated
        @exception SQLException if a database access error occurs
        """
        pass
    # end getURL
    del getURL

    def getUserName (self):
        """
        Retrieves the user name as known to this database.
        
        @return the database user name
        @exception SQLException if a database access error occurs
        """
        pass
    # end getUserName
    del getUserName

    def getVersionColumns (self, catalog, schema, table):
        """
        Retrieves a description of a table's columns that are automatically
        updated when any value in a row is updated.  They are
        unordered.
        
        <P>Each column description has the following columns:
        <OL>
        <LI><B>SCOPE</B> short => is not used
        <LI><B>COLUMN_NAME</B> String => column name
        <LI><B>DATA_TYPE</B> short => SQL data type from <code>java.sql.Types</code>
        <LI><B>TYPE_NAME</B> String => Data source-dependent type name
        <LI><B>COLUMN_SIZE</B> int => precision
        <LI><B>BUFFER_LENGTH</B> int => length of column value in bytes
        <LI><B>DECIMAL_DIGITS</B> short	 => scale
        <LI><B>PSEUDO_COLUMN</B> short => whether this is pseudo column 
        like an Oracle ROWID
        <UL>
        <LI> versionColumnUnknown - may or may not be pseudo column
        <LI> versionColumnNotPseudo - is NOT a pseudo column
        <LI> versionColumnPseudo - is a pseudo column
        </UL>
        </OL>
        
        @param catalog a catalog name; must match the catalog name as it
        is stored in the database; "" retrieves those without a catalog;
        <code>null</code> means that the catalog name should not be used to narrow
        the search
        @param schema a schema name; must match the schema name
        as it is stored in the database; "" retrieves those without a schema;
        <code>null</code> means that the schema name should not be used to narrow
        the search
        @param table a table name; must match the table name as it is stored 
        in the database 
        @return a <code>ResultSet</code> object in which each row is a 
        column description 
        @exception SQLException if a database access error occurs
        """
        pass
    # end getVersionColumns
    del getVersionColumns

    def insertsAreDetected (self, type):
        """
        Retrieves whether or not a visible row insert can be detected
        by calling the method <code>ResultSet.rowInserted</code>.
        
        @param type the <code>ResultSet</code> type; one of
        <code>ResultSet.TYPE_FORWARD_ONLY</code>,
        <code>ResultSet.TYPE_SCROLL_INSENSITIVE</code>, or
        <code>ResultSet.TYPE_SCROLL_SENSITIVE</code>
        @return <code>true</code> if changes are detected by the specified result
        set type; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end insertsAreDetected
    del insertsAreDetected

    def isCatalogAtStart (self):
        """
        Retrieves whether a catalog appears at the start of a fully qualified 
        table name.  If not, the catalog appears at the end.
        
        @return <code>true</code> if the catalog name appears at the beginning
        of a fully qualified table name; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end isCatalogAtStart

    def isReadOnly (self):
        """
        Retrieves whether this database is in read-only mode.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end isReadOnly

    def locatorsUpdateCopy (self):
        """
        Indicates whether updates made to a LOB are made on a copy or directly 
        to the LOB.
        @return <code>true</code> if updates are made to a copy of the LOB;
        <code>false</code> if updates are made directly to the LOB
        @throws SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end locatorsUpdateCopy
    del locatorsUpdateCopy

    def nullPlusNonNullIsNull (self):
        """
        Retrieves whether this database supports concatenations between 
        <code>NULL</code> and non-<code>NULL</code> values being 
        <code>NULL</code>.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end nullPlusNonNullIsNull

    def nullsAreSortedAtEnd (self):
        """
        Retrieves whether <code>NULL</code> values are sorted at the end regardless of 
        sort order.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end nullsAreSortedAtEnd

    def nullsAreSortedAtStart (self):
        """
        Retrieves whether <code>NULL</code> values are sorted at the start regardless 
        of sort order.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end nullsAreSortedAtStart

    def nullsAreSortedHigh (self):
        """
        Retrieves whether <code>NULL</code> values are sorted high.
        Sorted high means that <code>NULL</code> values
        sort higher than any other value in a domain.  In an ascending order,
        if this method returns <code>true</code>,  <code>NULL</code> values
        will appear at the end. By contrast, the method 
        <code>nullsAreSortedAtEnd</code> indicates whether <code>NULL</code> values
        are sorted at the end regardless of sort order.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end nullsAreSortedHigh

    def nullsAreSortedLow (self):
        """
        Retrieves whether <code>NULL</code> values are sorted low.
        Sorted low means that <code>NULL</code> values
        sort lower than any other value in a domain.  In an ascending order,
        if this method returns <code>true</code>,  <code>NULL</code> values
        will appear at the beginning. By contrast, the method 
        <code>nullsAreSortedAtStart</code> indicates whether <code>NULL</code> values
        are sorted at the beginning regardless of sort order.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end nullsAreSortedLow

    def othersDeletesAreVisible (self, type):
        """
        Retrieves whether deletes made by others are visible.
        
        @param type the <code>ResultSet</code> type; one of
        <code>ResultSet.TYPE_FORWARD_ONLY</code>,
        <code>ResultSet.TYPE_SCROLL_INSENSITIVE</code>, or
        <code>ResultSet.TYPE_SCROLL_SENSITIVE</code>
        @return <code>true</code> if deletes made by others
        are visible for the given result set type;
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end othersDeletesAreVisible
    del othersDeletesAreVisible

    def othersInsertsAreVisible (self, type):
        """
        Retrieves whether inserts made by others are visible.
        
        @param type the <code>ResultSet</code> type; one of
        <code>ResultSet.TYPE_FORWARD_ONLY</code>,
        <code>ResultSet.TYPE_SCROLL_INSENSITIVE</code>, or
        <code>ResultSet.TYPE_SCROLL_SENSITIVE</code>
        @return <code>true</code> if inserts made by others
        are visible for the given result set type;
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end othersInsertsAreVisible
    del othersInsertsAreVisible

    def othersUpdatesAreVisible (self, type):
        """
        Retrieves whether updates made by others are visible.
        
        @param type the <code>ResultSet</code> type; one of
        <code>ResultSet.TYPE_FORWARD_ONLY</code>,
        <code>ResultSet.TYPE_SCROLL_INSENSITIVE</code>, or
        <code>ResultSet.TYPE_SCROLL_SENSITIVE</code>
        @return <code>true</code> if updates made by others
        are visible for the given result set type;
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end othersUpdatesAreVisible
    del othersUpdatesAreVisible

    def ownDeletesAreVisible (self, type):
        """
        Retrieves whether a result set's own deletes are visible.
        
        @param type the <code>ResultSet</code> type; one of
        <code>ResultSet.TYPE_FORWARD_ONLY</code>,
        <code>ResultSet.TYPE_SCROLL_INSENSITIVE</code>, or
        <code>ResultSet.TYPE_SCROLL_SENSITIVE</code>
        @return <code>true</code> if deletes are visible for the given result set type;
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end ownDeletesAreVisible
    del ownDeletesAreVisible

    def ownInsertsAreVisible (self, type):
        """
        Retrieves whether a result set's own inserts are visible.
        
        @param type the <code>ResultSet</code> type; one of
        <code>ResultSet.TYPE_FORWARD_ONLY</code>,
        <code>ResultSet.TYPE_SCROLL_INSENSITIVE</code>, or
        <code>ResultSet.TYPE_SCROLL_SENSITIVE</code>
        @return <code>true</code> if inserts are visible for the given result set type;
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end ownInsertsAreVisible
    del ownInsertsAreVisible

    def ownUpdatesAreVisible (self, type):
        """
        
        Retrieves whether for the given type of <code>ResultSet</code> object,
        the result set's own updates are visible.
        
        @param type the <code>ResultSet</code> type; one of
        <code>ResultSet.TYPE_FORWARD_ONLY</code>,
        <code>ResultSet.TYPE_SCROLL_INSENSITIVE</code>, or
        <code>ResultSet.TYPE_SCROLL_SENSITIVE</code>
        @return <code>true</code> if updates are visible for the given result set type;
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end ownUpdatesAreVisible
    del ownUpdatesAreVisible

    def storesLowerCaseIdentifiers (self):
        """
        Retrieves whether this database treats mixed case unquoted SQL identifiers as
        case insensitive and stores them in lower case.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end storesLowerCaseIdentifiers

    def storesLowerCaseQuotedIdentifiers (self):
        """
        Retrieves whether this database treats mixed case quoted SQL identifiers as
        case insensitive and stores them in lower case.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end storesLowerCaseQuotedIdentifiers

    def storesMixedCaseIdentifiers (self):
        """
        Retrieves whether this database treats mixed case unquoted SQL identifiers as
        case insensitive and stores them in mixed case.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end storesMixedCaseIdentifiers

    def storesMixedCaseQuotedIdentifiers (self):
        """
        Retrieves whether this database treats mixed case quoted SQL identifiers as
        case insensitive and stores them in mixed case.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end storesMixedCaseQuotedIdentifiers

    def storesUpperCaseIdentifiers (self):
        """
        Retrieves whether this database treats mixed case unquoted SQL identifiers as
        case insensitive and stores them in upper case.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return true
    # end storesUpperCaseIdentifiers

    def storesUpperCaseQuotedIdentifiers (self):
        """
        Retrieves whether this database treats mixed case quoted SQL identifiers as
        case insensitive and stores them in upper case.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end storesUpperCaseQuotedIdentifiers

    def supportsANSI92EntryLevelSQL (self):
        """
        Retrieves whether this database supports the ANSI92 entry level SQL 
        grammar.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsANSI92EntryLevelSQL

    def supportsANSI92FullSQL (self):
        """
        Retrieves whether this database supports the ANSI92 full SQL grammar supported.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsANSI92FullSQL

    def supportsANSI92IntermediateSQL (self):
        """
        Retrieves whether this database supports the ANSI92 intermediate SQL grammar supported.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsANSI92IntermediateSQL

    def supportsAlterTableWithAddColumn (self):
        """
        Retrieves whether this database supports <code>ALTER TABLE</code>
        with add column.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsAlterTableWithAddColumn

    def supportsAlterTableWithDropColumn (self):
        """
        Retrieves whether this database supports <code>ALTER TABLE</code>
        with drop column.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsAlterTableWithDropColumn

    def supportsBatchUpdates (self):
        """
        Retrieves whether this database supports batch updates.
        
        @return <code>true</code> if this database supports batch upcates;
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        return true
    # end supportsBatchUpdates

    def supportsCatalogsInDataManipulation (self):
        """
        Retrieves whether a catalog name can be used in a data manipulation statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsCatalogsInDataManipulation

    def supportsCatalogsInIndexDefinitions (self):
        """
        Retrieves whether a catalog name can be used in an index definition statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsCatalogsInIndexDefinitions

    def supportsCatalogsInPrivilegeDefinitions (self):
        """
        Retrieves whether a catalog name can be used in a privilege definition statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsCatalogsInPrivilegeDefinitions

    def supportsCatalogsInProcedureCalls (self):
        """
        Retrieves whether a catalog name can be used in a procedure call statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsCatalogsInProcedureCalls

    def supportsCatalogsInTableDefinitions (self):
        """
        Retrieves whether a catalog name can be used in a table definition statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsCatalogsInTableDefinitions

    def supportsColumnAliasing (self):
        """
        Retrieves whether this database supports column aliasing.
        
        <P>If so, the SQL AS clause can be used to provide names for
        computed columns or to provide alias names for columns as
        required.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsColumnAliasing

    def supportsConvert (self):
        """
        Retrieves whether this database supports the <code>CONVERT</code>
        function between SQL types.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsConvert

    def supportsConvert (self, fromType, toType):
        """
        Retrieves whether this database supports the <code>CONVERT</code>
        for two given SQL types.
        
        @param fromType the type to convert from; one of the type codes from
        the class <code>java.sql.Types</code>
        @param toType the type to convert to; one of the type codes from 
        the class <code>java.sql.Types</code>
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @see Types
        """
        pass
    # end supportsConvert
    del supportsConvert

    def supportsCoreSQLGrammar (self):
        """
        Retrieves whether this database supports the ODBC Core SQL grammar.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsCoreSQLGrammar

    def supportsCorrelatedSubqueries (self):
        """
        Retrieves whether this database supports correlated subqueries.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsCorrelatedSubqueries

    def supportsDataDefinitionAndDataManipulationTransactions (self):
        """
        Retrieves whether this database supports both data definition and 
        data manipulation statements within a transaction.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsDataDefinitionAndDataManipulationTransactions

    def supportsDataManipulationTransactionsOnly (self):
        """
        Retrieves whether this database supports only data manipulation 
        statements within a transaction.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsDataManipulationTransactionsOnly

    def supportsDifferentTableCorrelationNames (self):
        """
        Retrieves whether, when table correlation names are supported, they 
        are restricted to being different from the names of the tables.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsDifferentTableCorrelationNames

    def supportsExpressionsInOrderBy (self):
        """
        Retrieves whether this database supports expressions in 
        <code>ORDER BY</code> lists.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsExpressionsInOrderBy

    def supportsExtendedSQLGrammar (self):
        """
        Retrieves whether this database supports the ODBC Extended SQL grammar.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsExtendedSQLGrammar

    def supportsFullOuterJoins (self):
        """
        Retrieves whether this database supports full nested outer joins.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsFullOuterJoins

    def supportsGetGeneratedKeys (self):
        """
        Retrieves whether auto-generated keys can be retrieved after 
        a statement has been executed.
        
        @return <code>true</code> if auto-generated keys can be retrieved
        after a statement has executed; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end supportsGetGeneratedKeys
    del supportsGetGeneratedKeys

    def supportsGroupBy (self):
        """
        Retrieves whether this database supports some form of 
        <code>GROUP BY</code> clause.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsGroupBy

    def supportsGroupByBeyondSelect (self):
        """
        Retrieves whether this database supports using columns not included in
        the <code>SELECT</code> statement in a <code>GROUP BY</code> clause 
        provided that all of the columns in the <code>SELECT</code> statement
        are included in the <code>GROUP BY</code> clause.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsGroupByBeyondSelect

    def supportsGroupByUnrelated (self):
        """
        Retrieves whether this database supports using a column that is
        not in the <code>SELECT</code> statement in a
        <code>GROUP BY</code> clause.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsGroupByUnrelated

    def supportsIntegrityEnhancementFacility (self):
        """
        Retrieves whether this database supports the SQL Integrity 
        Enhancement Facility.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsIntegrityEnhancementFacility

    def supportsLikeEscapeClause (self):
        """
        Retrieves whether this database supports specifying a
        <code>LIKE</code> escape clause.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsLikeEscapeClause

    def supportsLimitedOuterJoins (self):
        """
        Retrieves whether this database provides limited support for outer 
        joins.  (This will be <code>true</code> if the method 
        <code>supportsFullOuterJoins</code> returns <code>true</code>).
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsLimitedOuterJoins

    def supportsMinimumSQLGrammar (self):
        """
        Retrieves whether this database supports the ODBC Minimum SQL grammar.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsMinimumSQLGrammar

    def supportsMixedCaseIdentifiers (self):
        """
        Retrieves whether this database treats mixed case unquoted SQL identifiers as
        case sensitive and as a result stores them in mixed case.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsMixedCaseIdentifiers

    def supportsMixedCaseQuotedIdentifiers (self):
        """
        Retrieves whether this database treats mixed case quoted SQL identifiers as
        case sensitive and as a result stores them in mixed case.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsMixedCaseQuotedIdentifiers

    def supportsMultipleOpenResults (self):
        """
        Retrieves whether it is possible to have multiple <code>ResultSet</code> objects
        returned from a <code>CallableStatement</code> object
        simultaneously.
        
        @return <code>true</code> if a <code>CallableStatement</code> object
        can return multiple <code>ResultSet</code> objects
        simultaneously; <code>false</code> otherwise
        @exception SQLException if a datanase access error occurs
        @since 1.4
        """
        pass
    # end supportsMultipleOpenResults
    del supportsMultipleOpenResults

    def supportsMultipleResultSets (self):
        """
        Retrieves whether this database supports getting multiple 
        <code>ResultSet</code> objects from a single call to the
        method <code>execute</code>.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsMultipleResultSets

    def supportsMultipleTransactions (self):
        """
        Retrieves whether this database allows having multiple 
        transactions open at once (on different connections).
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsMultipleTransactions

    def supportsNamedParameters (self):
        """
        Retrieves whether this database supports named parameters to callable 
        statements.
        
        @return <code>true</code> if named parameters are supported; 
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end supportsNamedParameters
    del supportsNamedParameters

    def supportsNonNullableColumns (self):
        """
        Retrieves whether columns in this database may be defined as non-nullable.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsNonNullableColumns

    def supportsOpenCursorsAcrossCommit (self):
        """
        Retrieves whether this database supports keeping cursors open 
        across commits. 
        
        @return <code>true</code> if cursors always remain open;
        <code>false</code> if they might not remain open
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsOpenCursorsAcrossCommit

    def supportsOpenCursorsAcrossRollback (self):
        """
        Retrieves whether this database supports keeping cursors open 
        across rollbacks.
        
        @return <code>true</code> if cursors always remain open;
        <code>false</code> if they might not remain open
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsOpenCursorsAcrossRollback

    def supportsOpenStatementsAcrossCommit (self):
        """
        Retrieves whether this database supports keeping statements open 
        across commits.
        
        @return <code>true</code> if statements always remain open;
        <code>false</code> if they might not remain open
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsOpenStatementsAcrossCommit

    def supportsOpenStatementsAcrossRollback (self):
        """
        Retrieves whether this database supports keeping statements open 
        across rollbacks.
        
        @return <code>true</code> if statements always remain open;
        <code>false</code> if they might not remain open
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsOpenStatementsAcrossRollback

    def supportsOrderByUnrelated (self):
        """
        Retrieves whether this database supports using a column that is
        not in the <code>SELECT</code> statement in an
        <code>ORDER BY</code> clause.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsOrderByUnrelated

    def supportsOuterJoins (self):
        """
        Retrieves whether this database supports some form of outer join.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsOuterJoins

    def supportsPositionedDelete (self):
        """
        Retrieves whether this database supports positioned <code>DELETE</code>
        statements.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsPositionedDelete

    def supportsPositionedUpdate (self):
        """
        Retrieves whether this database supports positioned <code>UPDATE</code>
        statements.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsPositionedUpdate

    def supportsResultSetConcurrency (self, type, concurrency):
        """
        Retrieves whether this database supports the given concurrency type 
        in combination with the given result set type.
        
        @param type defined in <code>java.sql.ResultSet</code>
        @param concurrency type defined in <code>java.sql.ResultSet</code>
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        @see Connection
        @since 1.2
        """
        pass
    # end supportsResultSetConcurrency
    del supportsResultSetConcurrency

    def supportsResultSetHoldability (self, holdability):
        """
        Retrieves whether this database supports the given result set holdability.
        
        @param holdability one of the following constants:
        <code>ResultSet.HOLD_CURSORS_OVER_COMMIT</code> or
        <code>ResultSet.CLOSE_CURSORS_AT_COMMIT<code>
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        @see Connection
        @since 1.4
        """
        pass
    # end supportsResultSetHoldability
    del supportsResultSetHoldability

    def supportsResultSetType (self, type):
        """
        Retrieves whether this database supports the given result set type.
        
        @param type defined in <code>java.sql.ResultSet</code>
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        @see Connection
        @since 1.2
        """
        pass
    # end supportsResultSetType
    del supportsResultSetType

    def supportsSavepoints (self):
        """
        Retrieves whether this database supports savepoints.
        
        @return <code>true</code> if savepoints are supported; 
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.4
        """
        pass
    # end supportsSavepoints
    del supportsSavepoints

    def supportsSchemasInDataManipulation (self):
        """
        Retrieves whether a schema name can be used in a data manipulation statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsSchemasInDataManipulation

    def supportsSchemasInIndexDefinitions (self):
        """
        Retrieves whether a schema name can be used in an index definition statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsSchemasInIndexDefinitions

    def supportsSchemasInPrivilegeDefinitions (self):
        """
        Retrieves whether a schema name can be used in a privilege definition statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsSchemasInPrivilegeDefinitions

    def supportsSchemasInProcedureCalls (self):
        """
        Retrieves whether a schema name can be used in a procedure call statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsSchemasInProcedureCalls

    def supportsSchemasInTableDefinitions (self):
        """
        Retrieves whether a schema name can be used in a table definition statement.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end supportsSchemasInTableDefinitions

    def supportsSelectForUpdate (self):
        """
        Retrieves whether this database supports <code>SELECT FOR UPDATE</code>
        statements.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsSelectForUpdate

    def supportsStoredProcedures (self):
        """
        Retrieves whether this database supports stored procedure calls 
        that use the stored procedure escape syntax.
        
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsStoredProcedures

    def supportsSubqueriesInComparisons (self):
        """
        Retrieves whether this database supports subqueries in comparison 
        expressions.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsSubqueriesInComparisons

    def supportsSubqueriesInExists (self):
        """
        Retrieves whether this database supports subqueries in 
        <code>EXISTS</code> expressions.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsSubqueriesInExists

    def supportsSubqueriesInIns (self):
        """
        Retrieves whether this database supports subqueries in 
        <code>IN</code> statements.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsSubqueriesInIns

    def supportsSubqueriesInQuantifieds (self):
        """
        Retrieves whether this database supports subqueries in quantified 
        expressions.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsSubqueriesInQuantifieds

    def supportsTableCorrelationNames (self):
        """
        Retrieves whether this database supports table correlation names.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsTableCorrelationNames

    def supportsTransactionIsolationLevel (self, level):
        """
        Retrieves whether this database supports the given transaction isolation level.
        
        @param level one of the transaction isolation levels defined in 
        <code>java.sql.Connection</code>
        @return <code>true</code> if so; <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        @see Connection
        """
        pass
    # end supportsTransactionIsolationLevel
    del supportsTransactionIsolationLevel

    def supportsTransactions (self):
        """
        Retrieves whether this database supports transactions. If not, invoking the
        method <code>commit</code> is a noop, and the isolation level is 
        <code>TRANSACTION_NONE</code>.
        
        @return <code>true</code> if transactions are supported; 
        <code>false</code> otherwise 
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsTransactions

    def supportsUnion (self):
        """
        Retrieves whether this database supports SQL <code>UNION</code>.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsUnion

    def supportsUnionAll (self):
        """
        Retrieves whether this database supports SQL <code>UNION ALL</code>.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return true
    # end supportsUnionAll

    def updatesAreDetected (self, type):
        """
        Retrieves whether or not a visible row update can be detected by 
        calling the method <code>ResultSet.rowUpdated</code>.
        
        @param type the <code>ResultSet</code> type; one of
        <code>ResultSet.TYPE_FORWARD_ONLY</code>,
        <code>ResultSet.TYPE_SCROLL_INSENSITIVE</code>, or
        <code>ResultSet.TYPE_SCROLL_SENSITIVE</code>
        @return <code>true</code> if changes are detected by the result set type;
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        @since 1.2
        """
        pass
    # end updatesAreDetected
    del updatesAreDetected

    def usesLocalFilePerTable (self):
        """
        Retrieves whether this database uses a file for each table.
        
        @return <code>true</code> if this database uses a local file for each table;
        <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end usesLocalFilePerTable

    def usesLocalFiles (self):
        """
        Retrieves whether this database stores tables in a local file.
        
        @return <code>true</code> if so; <code>false</code> otherwise
        @exception SQLException if a database access error occurs
        """
        return false
    # end usesLocalFiles

